var bp_maps_google_is_init;

function bp_maps_init_geocoder(){
	if (!geocoder) {
		geocoder = new google.maps.Geocoder();
	}
};

function bp_maps_map_init(el) {
	//CHECK IF MAP HAS BEEN LOADED AND LOAD IT
	var map_div = el.parents('.bp_maps_map');
	var map_id = map_div.attr('rel');
	
	var map_loaded = eval(map_id+'_is_init');
	
	if (!map_loaded) {
		if (!bp_maps_google_is_init) {
			bp_maps_GoogleMaps.initialize(map_div);
		}else { //loaded before
			bp_maps_GoogleMaps.googleMapsLibraryLoaded();
		}
	}else {
		return true;
	}
}

jQuery(document).ready( function() {

	//INIT MAPS
	jQuery('.bp_maps_map_container img').click( function(event) {
		if (!bp_maps_map_init(jQuery(this))) return false;
	});
	
	var dynamics=jQuery('.bp_maps_map_container.dynamic');
	
	jQuery.each(dynamics, function() { 
		if (!bp_maps_map_init(jQuery(this))) return false;
	});
	


	//PRIVACY RADIO CLICKED
	jQuery('.bp_maps_privacy_action td').click( function(event) {
		bp_maps_map_privacy_rows_init(jQuery(this));

	});
	
	
	//CLICK "ADD MARKER" LINK
	jQuery('.bp_maps_map_add_marker a').click( function(event) {
	
		if (!bp_maps_map_init(jQuery(this))) return false;
	
		var map_id=bp_maps_get_parent_id(jQuery(this));
		
		bp_maps_new_geobox(map_id);
		return false;

	});
	
	//HOVER MARKERS
	jQuery('.bp_maps_marker').hover(function() {
	  jQuery(this).addClass('hover');
	}, function() {
	  jQuery(this).removeClass('hover');
	});
	

	
	//CLICK MARKER
	jQuery('.bp_maps_marker .item-title span').live('click',function() {
	
		if (!bp_maps_map_init(jQuery(this))) return false;
	
		var map_id=bp_maps_get_parent_id(jQuery(this));
	
		var marker_id=jQuery(this).attr('rel');

		var map_id=bp_maps_get_parent_id(jQuery(this));

		bp_maps_reset_view(map_id,marker_id);
	});
	
	//EDIT MARKERS
	jQuery('.bp_maps_marker .edit').live('click',function() {
	
		if (!bp_maps_map_init(jQuery(this))) return false;

		var marker_div=jQuery(this).parents('.bp_maps_marker');

		bp_maps_collapse_edit_markers(jQuery(this));
		marker_div.addClass('edit');
		marker_div.find('.item-title input').focus();

		return false;

	});
	
	//CLOSE
	jQuery('.bp_maps_marker .close').live('click',function() {
		bp_maps_collapse_edit_markers(jQuery(this));
		return false;

	});
	
	//SAVE MARKERS
	jQuery('.bp_maps_marker .save').live('click',function() {

		var marker_div=jQuery(this).parents('.bp_maps_marker');
		bp_maps_map_saveMarker(marker_div);
		
		var map_id=bp_maps_get_parent_id(marker_div);
		bp_maps_reset_view(map_id);
		return false;

	});
	
	//DELETE MARKERS
	jQuery('.bp_maps_marker .delete').live('click',function() {
		var marker_div=jQuery(this).parents('.bp_maps_marker');
		bp_maps_map_deleteMarker(marker_div);
		
		return false;

	});
	
	//SEARCH LOCATION
	jQuery('.bp_maps_marker .search').live('click',function() {
		
		bp_maps_init_geocoder();
		
		var map_id=bp_maps_get_parent_id(jQuery(this));


		var marker_id=bp_maps_marker_get_parent_id(jQuery(this));

		var markers=eval(map_id+'_markers');

		var input_address = jQuery('#'+map_id+'_marker'+marker_id+'_address');

		console.log(input_address);
		
		if (!input_address.val()) return false;

		jQuery(this).addClass('loading');
		
		bp_maps_map_moveMarker(map_id,marker_id,input_address);

		return false;

		
	});
	
	//DEL DIV IS VALUE IS EMPTY
	//TO FIX DO NOT WORK
	jQuery('.bp_maps_marker_field').live('focusout',function(){

		console.log("focusout");
		return;
		console.log("val"+jQuery.trim(jQuery(this).val()));
		if (jQuery.trim(jQuery(this).val())='') {
			console.log(empty);
		}

	});
	//DELETE MARKER
	jQuery('.bp_maps_marker_delete').live('click',function(){
		var map_id=bp_maps_get_parent_id(jQuery(this));
		
		var marker_id=bp_maps_marker_get_parent_id(jQuery(this));
		var markers = eval(map_id+'_markers');
		
		
		jQuery(this).parent('.bp_maps_marker').remove();

		return false;
		
	});

});

function bp_maps_collapse_edit_markers(el) {

	var markers_edit_div;

	if (el) {
		var map_id=bp_maps_get_parent_id(el);
		var map_div=bp_maps_marker_get_parent_map_div(map_id);
		markers_edit_div = map_div.find('.bp_maps_marker.edit');
	}else {
		markers_edit_div=jQuery('.bp_maps_marker.edit');
	}
	markers_edit_div.removeClass('edit');

}

function bp_maps_map_privacy_rows_init(cell){

	if (!cell)
		cell=jQuery('.bp_maps_privacy_action');
	
	jQuery.each(cell, function() { 
		var cells = jQuery(this).parent().find('td');
		var enable=false;

		cells.addClass('disabled');

		jQuery.each(cells, function(i) {
			
			if (jQuery(this).find('input[type="radio"]:checked').length)
					enable=true;
				
			if (enable)
				jQuery(this).removeClass('disabled');
			
			//last one and no one checked
			if ((i==cells.length-1) && (!enable))
				cells.removeClass('disabled');
		
		});

	});
	
}

function bp_maps_map_privacy(marker_div){
	var privacy = new Object();
	
	var actions  = marker_div.find('.privacy tr');
	
	jQuery.each(actions, function() { 
		var checkbox = jQuery(this).find('input[type="checkbox"]:checked');
		if (checkbox.length) {
			var radio = jQuery(this).find('input:checked');
			var name = radio.attr('name');
			var value = radio.val();
			privacy[name]=value;
		}
	});
	return privacy;
}

function bp_maps_map_saveMarker(marker_div) {
	
	var marker_id=marker_div.attr('rel');
	var map_div=marker_div.parents('.bp_maps_map');
	var map_id=map_div.attr('rel');
	
	var markers=eval(map_id+'_markers');
	var type=eval(map_id+'_type');
	
	var action;
	
	var point=new Object();
	var map_datas=new Object();
	
	
	marker_div.find('a.edit').addClass('loading');
	marker_div.find('input').attr('disabled',true);
	marker_div.find('.search').hide();
	
	
	//SPANS = INPUTS
	var title = marker_div.find('.item-title input').val();
	marker_div.find('.item-title span').html(title);
	var address = marker_div.find('.address input').val();
	marker_div.find('.address span').html(address);
	var desc = marker_div.find('.content input').val();
	marker_div.find('.content span').html(desc);

	var obj=markers[marker_id-1];

	if (!obj) {
		var message = 'You have to set a marker first';
		bp_maps_marker_message(map_id,marker_id,message,true);
		marker_div.find('a.edit').removeClass('loading');
		marker_div.find('input').removeAttr('disabled');
		marker_div.find('.search').show();
		return false;
	}

	if (obj.ID)
		point.ID=obj.ID;

	
	
	//NONCE
	var nonce_input = map_div.find("#"+map_id+"_nonce");

	var nonce = nonce_input.val();

	point.position=new Object();
	point.position.lat = obj['marker'].position.lat();
	point.position.lng = obj['marker'].position.lng();
	point.title = title;
	point.desc = desc;
	point.type = type;
	point.address = address;
	point.privacy = bp_maps_map_privacy(marker_div);
	
	//console.log(point.privacy);
	//marker_div.find('input').removeAttr('disabled');
	//return;

	
	point = jQuery.toJSON(point);

	j.post( ajaxurl, {
		action: 'bp_maps_map_marker_save',
		'_wpnonce': nonce,
		point:point,
		map_id:map_id
	},
	function(response)
	{
		marker_div.find('a.edit').removeClass('loading');
		marker_div.find('input').removeAttr('disabled');
		marker_div.find('.search').show();
		
		response =jQuery.evalJSON(response);

		if (response.ID) {
			markers[marker_id-1].ID=response.ID;
			marker_div.removeClass('edit');
			marker_div.find('a.edit').html('Edit');
		
		bp_maps_marker_message(map_id,marker_id,response.msg);
		}else {
			bp_maps_marker_message(map_id,marker_id,response.msg,true);
		}

	});
	return false;

}

function bp_maps_map_deleteMarker(marker_div) {
	
	var marker_id=marker_div.attr('rel');
	var map_div=marker_div.parents('.bp_maps_map');
	var map_id=map_div.attr('rel');
	
	var markers=eval(map_id+'_markers');
	
	var action;
	
	var remove_ID;

	var obj=markers[marker_id-1];

	if (!obj) {
		marker_div.remove();
		return false;
	}
	
	var map = obj['marker'].map;

	if (obj.ID)
		remove_ID=obj.ID;
		
	marker_div.find('a.edit').addClass('loading');
	marker_div.find('input').attr('disabled',true);
	marker_div.find('.search').hide();

	
	
	//NONCE
	var nonce_input = map_div.find("#"+map_id+"_nonce");

	var nonce = nonce_input.val();

	j.post( ajaxurl, {
		action: 'bp_maps_map_marker_delete',
		'_wpnonce': nonce,
		ID:remove_ID,
		map_id:map_id
	},
	function(response)
	{
		marker_div.find('a.edit').removeClass('loading');
		marker_div.find('input').removeAttr('disabled');
		marker_div.find('.search').show();
		
		response =jQuery.evalJSON(response);

		
		if (response.result) {
			//TO FIX : remove marker from MAP
			//map.removeOverlay(obj['marker']);
			marker_div.parent('li').remove();
			bp_maps_reset_view(map_id);
		}else {
			bp_maps_marker_message(map_id,marker_id,response.msg,true);
		}

	});
	return false;

}

function bp_maps_marker_message(map_id,marker_id,msg,error) {

	marker_div=jQuery('#'+map_id+'_marker'+marker_id);

	msg_div=marker_div.find('.message');
	msg_div.addClass('updated');
	msg_div.addClass('fade');
	
	if (error)
		msg_div.addClass('fade');
		
	msg_div.html(msg);
}

function bp_maps_count_markers(map_id) {
	var markers = eval(map_id+'_markers');
	return markers.length;
	
}


function bp_maps_replace_text(text,needle,replacement) {

     var match = new RegExp(needle, "ig");     
     var replaced = text.replace(match, replacement);
	 
	 return replaced;

}



function bp_maps_new_geobox(map_id) {
		var marker;
		var marker_id;
		var newmarker_title='';
		var newmarker_address='';
		var newmarker_content='';


		var map_div=bp_maps_marker_get_parent_map_div(map_id);


		var markers = eval(map_id+'_markers');
		
		var markers_div = jQuery('#'+map_id+'_markers');


		var markers_count=markers.length;
		var markers_max=eval(map_id+'_markers_max');
		
		//BUG : SEEMS MARKER IS STILL IN markers ARRAY
		console.log("bug here");

		//LAST HAS NOT BEEN SAVED
		if ((markers_count) && (!bp_maps_map_get_last_marker(map_id))) {
			bp_maps_map_last_marker_focus(map_id);
			return false;
		}

		
		//BREAK IF MAX MARKERS
		if ((markers_max) && (markers_count>=markers_max)) return false;
		
		
		bp_maps_collapse_edit_markers();

		var newmarker_id=jQuery('.bp_maps_marker').length+1;
		var newmarker_div;

		var add_markers_link=markers_div.find('.bp_maps_map_add_marker');
		
		var geobox=map_div.find('.bp_maps_map_markers li:first');

		//replace MARKER ID by new one
		var newcount = markers_count+1
		var marker_id_in='_marker'+markers_count;
		var marker_id_out='_marker'+newcount;
		new_html=bp_maps_replace_text(geobox.html(),marker_id_in,marker_id_out);

		clone=jQuery(new_html);
		clone.addClass('edit');
		clone.attr('rel',newcount);
		
		clone.find('span').empty(); //removes span text
		clone.find('input[type=text]').val('');
		
		clone.insertAfter(add_markers_link);


		
		var input=clone.find(".address .input");
		input.focus();

		return false;
}


function bp_maps_map_get_last_marker(map_id) {
	if (!map_id) return false;
	
	var marker_id = jQuery('#'+map_id+'_markers .bp_maps_marker:first').attr('rel');
	
	var markers=eval(map_id+'_markers');
	
	obj=markers[marker_id-1];

	return obj;
}

function bp_maps_map_last_marker_focus(map_id) {
	var last_marker = jQuery('#'+map_id+'_markers .bp_maps_marker:first');
	last_marker.addClass('edit');
	var input_addr = last_marker.find('.address input');

	input_addr.focus();
}


function bp_maps_map_moveMarker(map_id,marker_id,input_address) {
		
		var address=input_address.val();
		var marker_div;

		if (geocoder) {

		  geocoder.geocode( { 'address': address}, function(results, status) {
			if (status == google.maps.GeocoderStatus.OK) {
			
				coords=results[0].geometry.location;

				//remove Loading Class
				marker_div=jQuery('#'+map_id+'_marker'+marker_id);
				var marker_search_link = marker_div.find('a.search');
				marker_search_link.removeClass('loading');
				
				//get Marker
				var markers=eval(map_id+'_markers');
				var markers_max=eval(map_id+'_markers_max');
				
				var obj = markers[marker_id-1];
				
					
				var map = eval(map_id+'_map');

				//marker do not exists yet
				if (!obj) {

					if (markers.length>markers_max)
						return false;

					new_marker = bp_maps_map_addMarker(map_id);
					marker = new_marker['marker'];
				//marker exists
				}else {
					marker = obj['marker'];
				}
				
				marker.setPosition(coords);
				bp_maps_reset_view(map_id,marker_id);


			} else {
				//remove Loading Class
				marker_div=jQuery('#'+map_id+'_marker'+marker_id);
				var marker_search_link = marker_div.find('a.search');
				marker_search_link.removeClass('loading');
				
				var msg_div=marker_div.find('.message');
				msg_div.addClass('updated fade error');
				msg_div.html("Geocode was not successful for the following reason: " + status);
			}
		  });
		}
}

function bp_maps_get_parent_id(el) {

	var map_id=el.parents('.bp_maps_map').attr('rel');

	return map_id;
}

function bp_maps_marker_get_parent_id(el) {

	var marker_id=el.parents('.bp_maps_marker').attr('rel');

	
	return marker_id;
}


function bp_maps_marker_get_parent_map(el) {

	map  = eval(bp_maps_marker_get_parent_map_name(el));

	return map;
}

function bp_maps_marker_get_parent_map_div(map_id) {


	return jQuery('#'+map_id);
}

function bp_maps_marker_get_parent_map_name(el) {

	var map_id=bp_maps_get_parent_id(el);
	
	return map_id+'_map';
}


function bp_maps_map_addMarker(map_id) {

	
	markers=eval(map_id+'_markers');
	
	

	var markers_max=eval(map_id+'_markers_max');
	
	markers=eval(map_id+'_markers');
	markers_count = jQuery(markers).length;



	if (markers_count>=markers_max)
		return false;
	
	//NEW MARKER ID
	var marker_id=markers_count;

	if (markers[marker_id])
		return false;

		

	var mapname=map_id+'_map';
	markers[marker_id] = new Object();
	markers[marker_id]['marker'] = new google.maps.Marker({map: eval(mapname),draggable:true,position: eval(mapname).getCenter()});
	markers[marker_id]['ID'] ='';

	markers=eval(map_id+'_markers');
	markers_count = jQuery(markers).length;
	
	return markers[marker_id];

}



function bp_maps_address_to_coords(address) {
	if (geocoder) {
	
	  geocoder.geocode( { 'address': address}, function(results, status) {
		if (status == google.maps.GeocoderStatus.OK) {

			coords=results[0].geometry.location;

			return coords;

		} else {
		  alert("Geocode was not successful for the following reason: " + status);
		}
	  });
	}
}

function bp_maps_get_marker(map_id,marker_id) {
	var markers = eval(map_id+'_markers');
	var marker = markers[marker_id-1]['marker'];
	return marker;
}

function bp_maps_get_markers_positions(map_id) {

	var markers = eval(map_id+'_markers');
	var list=new Array();

		var markers_count = jQuery(markers).length;

		jQuery.each(markers, function(ID, obj) { 
			if (obj) {
				if (obj['marker'])
					list.push(obj['marker'].position);
			}
		});


	return list;
}


function bp_maps_reset_view(map_id,marker_id) {

	var map = eval(map_id+'_map');

	//  Make an array of the LatLng's of the markers you want to show

	
	if (marker_id) {
		var marker = bp_maps_get_marker(map_id,marker_id);
		map.setCenter(marker.position);
		return;
	}
	
	var LatLngList = bp_maps_get_markers_positions(map_id);
	
	if (!LatLngList) return false;
	
	if (LatLngList.length<=1) return false;

	//  Create a new viewpoint bound
	var bounds = new google.maps.LatLngBounds();
	//  Go through each...

	for (var i = 0, LtLgLen = LatLngList.length; i < LtLgLen; i++) {
	  //  And increase the bounds to take this point
	  bounds.extend (LatLngList[i]);
	}
	//  Fit these bounds to the map
	
	
	
	map.fitBounds (bounds);


}

