<?php

function bp_maps_admin_js($hook_suffix) {

	if ($hook_suffix!='buddypress_page_bp-maps-setup') return false;
	wp_enqueue_script('jquery-ui-tabs');
	
	wp_enqueue_style( 'bp-maps-admin-tabs', BP_MAPS_PLUGIN_URL . '/_inc/css/jquery.ui.tabs.css' );
	wp_enqueue_script( 'bp-maps-admin', BP_MAPS_PLUGIN_URL . '/_inc/js/admin-maps.js' );	
	//wp_enqueue_style( 'bp-maps-admin', BP_MAPS_PLUGIN_URL . '/css/admin.css' );

}
add_action('admin_enqueue_scripts', 'bp_maps_admin_js',1);

function bp_maps_admin() {
	global $bp;
	global $current_site;
	global $errors;

	$options=$bp->maps->options;
	
	//delete_site_option( 'bp_maps_options');
	
	if ( isset( $_POST['submit'] ) ) {
		$_options=array();
		
		if (!$errors)
			$errors = new WP_Error();

		switch ( $_POST['action'] ) {
			
			/*
			case 'system-install':
			break;
			*/
		
			case 'options':
			
				check_admin_referer('maps-options');
				
				//api key
				$api_key = trim($_POST['bp_maps_api_key']);
				if (!empty($api_key)) {
					$_options['api_key'] = $api_key;
				}else {
					$errors->add('apikey',__( 'You have to enter your api key.', 'bp-maps' ));
				}
				
				//MAPS OPTIONS
				//size

				foreach ($options['map']['sizes'] as $size=>$value) {

					if (
						(($_POST['bp_maps_map_size_'.$size.'_width'])&&(is_numeric($_POST['bp_maps_map_size_'.$size.'_width']))) 
						&& (($_POST['bp_maps_map_size_'.$size.'_height']) &&((is_numeric($_POST['bp_maps_map_size_'.$size.'_width']))))
					) {
						
						
						$_options['map']['sizes'][$size]=array('width'=>$_POST['bp_maps_map_size_'.$size.'_width'],'height'=>$_POST['bp_maps_map_size_'.$size.'_height']);
					}else {
						$errors->add('map_size_'.$size,sprintf(__( 'Please specify a valid size for the %s maps', 'maps' ),$size));
					}
				}

				//default
				$_options['map']['options']['size'] = $_POST['bp_maps_map_size_default'];
				
				//Display
				if (!empty($_POST['bp_maps_map_display']))
					$_options['map']['options']['display'] = $_POST['bp_maps_map_display'];

				//zoom
				if (($_POST['bp_maps_map_zoom']) && (is_numeric($_POST['bp_maps_map_zoom']))) {
					$_options['map']['options']['zoom'] = $_POST['bp_maps_map_zoom'];
				}else {
					$errors->add('zoom',__( 'Zoom must be a number', 'maps' ));
				}
				//center
				if ($_POST['bp_maps_map_center']) {
					$location=explode(',',$_POST['bp_maps_map_center']);
					if ((is_array( $location)) && ((is_numeric($location[0])) && (is_numeric($location[1])))) {
						$_options['map']['options']['center'] = implode(',',$location);
					}else{
						$errors->add('zoom',__( 'Latitude/Longitude must be numbers', 'maps' ));
					}
				}

				//mapTypeControlOptions
				if (!empty($_POST['bp_maps_map_TypeControlOptions']))
					$_options['map']['options']['mapTypeControlOptions'] = $_POST['bp_maps_map_TypeControlOptions'];
				//navigationControlOptions
				if (!empty($_POST['bp_maps_map_navigationControlOptions']))
					$_options['map']['options']['navigationControlOptions'] = $_POST['bp_maps_map_navigationControlOptions'];
				//mapTypeId
				$_options['map']['options']['mapTypeId'] = $_POST['bp_maps_map_mapTypeId'];
				
			//POSTING
				//markers max
				if (($_POST['bp_maps_map_markers_max']) && (is_numeric($_POST['bp_maps_map_markers_max']))) {
					$_options['map']['options']['markers_max'] = $_POST['bp_maps_map_markers_max'];
				}else {
					$errors->add('markers_max',__( 'Max. markers must be a number', 'maps' ));
				}
				
				//editable fields
				$_options['map']['options']['enable_desc']=(bool)$_POST['bp_maps_map_enable_desc'];

				
			break;
			case 'r-c';
				check_admin_referer('maps-settings-r-c');
				
				$roles_names = bp_maps_get_roles_names();
				
				if ($_POST['reset-r-c']) {
					foreach ($roles_names as $key=>$name) {
						if ($key=='administrator') continue;

						if (!delete_option('maps_r&c_'.$key)) {
							$error=true;
						}
					}
					if ($error) {
						$errors->add('r_c_error_reset',__( 'Error while trying to reset capabilities.', 'maps' ));
					}
				}else {
					
					//TO FIX : error when nothing is checked
				
					$capabilities = $bp->maps->capabilities;
					
					foreach($roles_names as $role => $name)
					{
						$role_capabilities = $_POST['cap'][$role];
						
						if ($role=='administrator') continue;
						
						if (update_option('maps_r&c_'.$role, $role_capabilities)) {
							$r = get_role($role);
							
							if ($role!='default') {
							
								foreach ($capabilities as $capability => $v)
								{
									if (isset($role_capabilities[$capability])) {
										$r->add_cap($capability);
									}else {
										$r->remove_cap($capability);
									}
								}
								
							}
						}else {
							$error=true;
						}
					}

					if ($error) 
						$errors->add('r_c_error_save',__( 'Error while trying to save capabilities.', 'maps' ));

				}
				$message = __( 'Settings saved.', 'buddypress' );
			
			break;
			case 'system-options':

				check_admin_referer('bp-maps-system-options');

				//TO FIX : do not save options
				
				//DEBUG
				$_options['enable_debug'] = (bool) $_POST['enable_debug'];
				
				//RESET OPTIONS
				if ($_POST['reset-options']) {
					if (!delete_site_option( 'bp_maps_options')) {
						$errors->add('reset_options',__( 'Error while trying to reset options', 'maps' ));
					}else {
						unset($_options);
						unset($options);
					}
				}
				//CLEAR DATA
				if ($_POST['clear-data']) {
					//TO FIX
				}
				//UNINSTALL PLUGIN
				if ($_POST['uninstall-plugin']) {
					//TO FIX	
				}
			break;
		}
		
		//PLUGINS
		do_action( 'bp_maps_admin_save');
		

		$options = wp_parse_args( $_options, $options ); //changes full array options with updated values
		if (update_site_option( 'bp_maps_options', $options ))
			$message = __('Settings saved','maps');
		
 		do_action( 'bp_maps_admin_screen',$options );
		
		//TO FIX : CHECK showing
		if ($errors->get_error_message($code)) {
		?>
			<div id="message" class="error">
				<p><?php echo $errors->get_error_message($code);?></p>
			</div>
		<?php }elseif ($message) {
		?>
			<div id="message" class="info">
				<p><?php echo $message;?></p>
			</div>
		<?php
		}

		
	
	}
	?>


	<div id="slider" class="wrap">
		<ul id="tabs">
			<?php
			
			$donations_tab='<li><a href="#donations">'.__("Support & Donations", "maps").'</a></li>';
			
			if (!bp_maps_is_setup()) {
					echo $donations_tab;
			} ?>
			
			<li><a href="#options"><?php _e( 'Options', 'maps' ) ?></a></li>
			<?php do_action( 'bp_maps_admin_tabs' );?>
			<li><a href="#system"><?php _e('System', 'support') ;?></a></li>
			<li><a href="#r-c"><?php _e( 'Roles & Capabilities', 'maps' ) ?></a></li>
			<?php
			if (bp_maps_is_setup()) {
					echo $donations_tab;
			} ?>
			
			
		</ul>

		<br />
		<div id="system">
			<h2><?php _e('System', 'maps') ;?></h2>
			<form action="#system" name="bp-maps-options" id="bp-maps-options" method="post">	
				<h3><?php _e('Reset Options', 'maps') ;?></h3>
				<p>
					<input name="reset-options" type="checkbox" id="reset-options" value="1"/>
					<?php _e( 'Reset all plugin options', 'maps' ); ?>
					 - <small><?php _e( 'This will not affect the content (maps and categories)', 'maps' ); ?></small>
					</p>
				</p>
				<p>
					<input name="clear-data" type="checkbox" id="clear-data" value="1"/>
					<?php _e( 'Clear all maps datas', 'maps' ); ?>
					</p>
				</p>
				<p>
					<input name="uninstall-plugin" type="checkbox" id="uninstall-plugin" value="1"/>
					<?php _e( 'Totally uninstall the plugin, maps included !', 'maps' ); ?>
				</p>
				<!--
				<h3><?php _e('Maintenance', 'maps') ;?></h3>
				<table class="form-table">
						<tr valign="top">
							<th scope="row"><label for="enable_debug"><?php _e( 'Enable debugging', 'maps' ) ?></label></th>
							<td>
								<input name="enable_debug" type="checkbox" id="enable_debug" value="1"<?php echo( $options['enable_debug'] ? ' checked="checked"' : '' ); ?><?php if (!bp_maps_plugin_is_active('wp-firephp/wp-firephp.php')) echo " DISABLED"; ?>/>
								<?php printf(__( 'You will need the plugin %s activated sitewide to enable this funtion', 'maps' ),'<a href="http://wordpress.org/extend/plugins/wp-firephp/">WP-FirePHP</a>');?>
							</td>
						</tr>
					<tr valign="top">
						<th scope="row"><label for="autoprune_drafts"><?php _e( 'Auto prune maps drafts', 'maps' ); ?></label></th>
						<td>
							<input name="autoprune_drafts" type="text" id="autoprune_drafts" size="3" value="<?php echo $options['autoprune_drafts'];?>"/> <?php _e('days','maps');?>
							 - <small><?php _e( 'Leave empty if you want to disable this', 'maps' ); ?></small>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="autoprune_drafts"><?php _e( 'Auto prune unactive maps', 'maps' ); ?></label></th>
						<td>
							<input name="autoprune_unactive" type="text" id="autoprune_unactive" size="3" value="<?php echo $options['autoprune_unactive'];?>"/> <?php _e('days','maps');?>
							 - <small><?php _e( 'Leave empty if you want to disable this', 'maps' ); ?></small>
						</td>
					</tr>
				</table>
				-->
				<p id="submit-types" class="submit">
				<input type="hidden" name="action" value="system-options" />
				<input class="button-primary" type="submit" name="submit" value="<?php _e('Save system Options', 'maps') ?>"/>
			</p>
			<?php wp_nonce_field('bp-maps-system-options') ?>
			
		</div>
		<div id="options">
			<h2><?php _e( 'Options', 'maps' ) ?></h2>
			
			<form action="#options" name="bp-maps-options" id="bp-maps-options" method="post">				
			<h3><?php _e( 'Maps Options', 'maps' ) ?></h3>
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><label for="bp_maps_api_key"><?php _e('Api Key','bp-maps'); ?></label></th>
						<td>
							<input class="required" name="bp_maps_api_key" type="text" id="bp_maps_api_key" size="50" value="<?php echo $options['api_key'];?>"/>
						</td>
					</tr>
				</table>
			<h4><?php _e( 'Maps Sizes', 'maps' ) ?></h4>
				<table class="form-table">
					<?php
					foreach ($options['map']['sizes'] as $size=>$value) {
					?>
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_size_<?php echo $size;?>"><?php echo $size; ?></label></th>
						<td>
							<input class="required" name="bp_maps_map_size_<?php echo $size;?>_width" type="text" id="bp_maps_map_size_<?php echo $size;?>_width" size="5" value="<?php echo $options['map']['sizes'][$size]['width'];?>"/>x
							<input class="required" name="bp_maps_map_size_<?php echo $size;?>_height" type="text" id="bp_maps_map_size_<?php echo $size;?>_height" size="5" value="<?php echo $options['map']['sizes'][$size]['height'];?>"/>
							<small> - px</small>
						</td>
					</tr>
					<?php
					}
					?>

					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_size_default"><?php _e('Default Map Size', 'bp-maps') ?></label></th>
						<td>
							<select name="bp_maps_map_size_default"> 
								<?php
								foreach ($options['map']['sizes'] as $size=>$value) {
								?>
									<option value="<?php echo $size;?>"<?php if ($options['map']['options']['size']==$size)echo" SELECTED";?>><?php echo $size;?>
								<?php
								}
								?>
							</select>
						</td>
					</tr>
				</table>

				<h4><?php _e( 'Maps Default Options', 'maps' ) ?></h4>
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_TypeControlOptions"><?php _e('Display', 'bp-maps') ?></label></th>
						<td>
							<select name="bp_maps_map_display">
								<option value="both"<?php if (!$options['map']['options']['display']=='both')echo" SELECTED";?>><?php _e('Displays a picture first, then loads the map at user\'s click', 'bp-maps') ?>
								<option value="static"<?php if ($options['map']['options']['display']=='static')echo" SELECTED";?>><?php _e('Display a picture only', 'bp-maps') ?>
								<option value="dynamic"<?php if ($options['map']['options']['display']=='dynamic')echo" SELECTED";?>><?php _e('Display the complete map', 'bp-maps') ?>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_zoom"><?php _e('Zoom', 'bp-maps') ?></label></th>
						<td>
							<input class="required" name="bp_maps_map_zoom" type="text" id="bp_maps_map_zoom" size="2" value="<?php echo $options['map']['options']['zoom'];?>"/>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_center"><?php _e('Default Location', 'bp-maps') ?></label></th>
						<td>
							<input class="required" name="bp_maps_map_center" type="text" id="bp_maps_map_center" size="20" value="<?php echo $options['map']['options']['center'];?>"/>
							<small><?php _e('Latitude', 'bp-maps') ?>,<?php _e('Longitude', 'bp-maps') ?></small>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_TypeControlOptions"><?php _e('Control Options', 'bp-maps') ?></label></th>
						<td>
							<select name="bp_maps_map_TypeControlOptions">
								<option value=""<?php if (!$options['map']['options']['mapTypeControlOptions'])echo" SELECTED";?>><?php _e('none', 'bp-maps') ?>
								<option value="DEFAULT"<?php if ($options['map']['options']['mapTypeControlOptions']=='DEFAULT')echo" SELECTED";?>><?php _e('DEFAULT', 'bp-maps') ?>
								<option value="HORIZONTAL_BAR"<?php if ($options['map']['options']['mapTypeControlOptions']=='HORIZONTAL_BAR')echo" SELECTED";?>><?php _e('HORIZONTAL_BAR', 'bp-maps') ?>
								<option value="DROPDOWN_MENU"<?php if ($options['map']['options']['mapTypeControlOptions']=='DROPDOWN_MENU')echo" SELECTED";?>><?php _e('DROPDOWN_MENU', 'bp-maps') ?>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_navigationControlOptions"><?php _e('Navigation Control Options', 'bp-maps') ?></label></th>
						<td>
							<select name="bp_maps_map_navigationControlOptions">  
								<option value=""<?php if (!$options['map']['options']['navigationControlOptions'])echo" SELECTED";?>><?php _e('none', 'bp-maps') ?>
								<option value="DEFAULT"<?php if ($options['map']['options']['navigationControlOptions']=='DEFAULT')echo" SELECTED";?>><?php _e('DEFAULT', 'bp-maps') ?>
								<option value="ZOOM_PAN"<?php if ($options['map']['options']['navigationControlOptions']=='ZOOM_PAN')echo" SELECTED";?>><?php _e('ZOOM_PAN', 'bp-maps') ?>
								<option value="SMALL"<?php if ($options['map']['options']['navigationControlOptions']=='SMALL')echo" SELECTED";?>><?php _e('SMALL', 'bp-maps') ?>
								<option value="ANDROID"<?php if ($options['map']['options']['navigationControlOptions']=='ANDROID')echo" SELECTED";?>><?php _e('ANDROID', 'bp-maps') ?>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_mapTypeId"><?php _e('map Type', 'bp-maps') ?></label></th>
						<td>
							<select name="bp_maps_map_mapTypeId">  
								<option value="ROADMAP"<?php if ($options['map']['options']['mapTypeId']=='ROADMAP')echo" SELECTED";?>><?php _e('ROADMAP', 'bp-maps') ?>
								<option value="SATELLITE"<?php if ($options['map']['options']['mapTypeId']=='SATELLITE')echo" SELECTED";?>><?php _e('SATELLITE', 'bp-maps') ?>
								<option value="HYBRID"<?php if ($options['map']['options']['mapTypeId']=='HYBRID')echo" SELECTED";?>><?php _e('HYBRID', 'bp-maps') ?>
								<option value="TERRAIN"<?php if ($options['map']['options']['mapTypeId']=='TERRAIN')echo" SELECTED";?>><?php _e('TERRAIN', 'bp-maps') ?>
							</select>
						</td>
					</tr>
				</table>

				<h4><?php _e( 'Posting Markers Defaults', 'maps' ) ?></h4>
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_markers_max"><?php _e('Markers max.', 'bp-maps') ?></label></th>
						<td>
							<input class="required" name="bp_maps_map_markers_max" type="text" id="bp_maps_map_markers_max" size="2" value="<?php echo $options['map']['options']['markers_max'];?>"/>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="bp_maps_map_enable_desc"><?php _e('Enable title/description', 'bp-maps') ?></label></th>
						<td>
							<input class="required" name="bp_maps_map_enable_desc" type="checkbox" id="bp_maps_map_enable_desc" value="1"<?php if ($options['map']['options']['enable_desc'])echo" CHECKED";?>/>
						</td>
					</tr>
				</table>
					
				<?php do_action( 'bp_maps_admin_options' );?>
				
				<br />
				<p class="submit">
					<input type="hidden" name="action" value="options" />
					<input class="button-primary" type="submit" name="submit" value="<?php _e('Save Settings', 'buddypress') ?>"/>
				</p>
				<?php wp_nonce_field('maps-options') ?>
			</form>
		</div>
		<div id='r-c'>
			<h2><?php _e( 'Roles & Capabilities', 'bp-maps' ) ?></h2>
			<form action="#r-c" name="bp-maps-r-c" id="bp-maps-r-c" method="post">
				<table class='form-table'>
					<?php
					$capabilities = $bp->maps->capabilities;

					
					$capability_groups = array(
						'markers' => __('View Markers', 'bp-maps'),
						'my-markers' => __('Create Markers', 'bp-maps'),
						'my-markers-hide' => __('At marker creation, allow user to hide it for', 'bp-maps'),
						'my-markers-show-approx' => __('At marker creation, allow user to choose to show approximate location for', 'bp-maps'),
						
					);
					$grouping_cap = array();
					foreach ($capabilities as $capability => $v)	$grouping_cap[$v['group']] [$capability] = null;

					$roles_names=bp_maps_get_roles_names();

					$counter_tr=0;
					foreach($roles_names as $role => $name)
					{
					
					
					
						if ('administrator' == $role) continue;
						$name = translate_with_context($name);
						$rcs = get_option('maps_r&c_' . $role);
						
						//TR CLASSES

						unset($tr_classes);
						unset($tr_classes_str);
						
						$tr_classes[]='mp_sep';
						$tr_classes[]=$role;
						if (empty($rcs))	$tr_classes[]='no_data';
						if (($counter_tr % 2))	$tr_classes[]='alt';
						
						if ($tr_classes)
							$tr_classes_str=' class="'.implode(' ',$tr_classes).'"';
						
					?>
								<tr<?php echo $tr_classes_str;?>>
									<th scope='row' style='width:100px;'><strong><?php echo $name; ?></strong></th>
									<td style='padding:0;'>
										<table>
											<?php
												$col = 6;
												$counter=0;
												foreach ($capability_groups as $group => $groupname)
												{

													if (($role=='default') && ($group=='admin')) continue;

													if (!isset($grouping_cap[$group])) continue;
													
													echo "<tr><td class='capacity name' colspan='" . ($col+1) . "'><i>$groupname</i></td></tr>";
													$i = 0;
													foreach ($grouping_cap[$group] as $capability => $v)
													{
														$capname = $capabilities[$capability]['name'];
																	
														if (0 == $i)	echo "<tr class='".$capability."'><td class='capacity' style='width:10px'></td>\n";
														
														unset($checked);
														if ($rcs) {
															if ($rcs[$capability]) $checked=true;
														}else {
															$checked = $capabilities[$capability]['default'];
														}
														
														
											?>
																		<td class='capacity'>
																			<label for='<?php echo "check_" . $role . "_" . $capability; ?>'>
																				<input class="<?php echo $capability; ?>" id='<?php echo "check_" . $role . "_" . $capability; ?>' name='cap[<?php echo $role; ?>][<?php echo $capability; ?>]' type='checkbox'<?php echo (isset($checked)) ? " checked='checked'" : ''; ?>/>
																				<span id='<?php echo $role . "_" . $capability; ?>' class='<?php echo (isset($checked)) ? 'crok' : 'crko'; ?>'><?php echo $capname; ?></span>
																			</label>
																		</td>
											<?php
														$i++;
														if (intval($i/$col) == ( $i/$col)) {$i = 0; echo "</tr>\n"; }
													}
													$tr = false;
													while (intval($i/$col) != ($i/$col)) { echo "<td style='border-bottom:none;'></td>\n"; $tr = true; $i++;}
													if ($tr) echo "</tr>\n";
												}
										?></table><?php
						$counter_tr++;
					}
					?>
				</table>
				<p id="submit-r-c" class="submit">
					<?php 
						if (!bp_maps_plugin_is_active('buddypress-maps/bp-maps-roles-and-capabilities.php')) {
							echo'<p>';
							printf(__('if you want precise control on each Wordpress role, enable the plugin %s'),'<em>BuddyPress Maps Roles & Capabilities</em>');
							echo'</p>';
						}?>
					<input type="hidden" name="action" value="r-c" />
					<input class="button-primary" type="submit" name="submit" value="<?php _e('Save Settings', 'buddypress') ?>"/>
					<input id="reset-r-c" name="reset-r-c" type="checkbox" value="1"/><?php _e('Reset Capabilities', 'maps') ?>
				</p>
				<?php wp_nonce_field('maps-settings-r-c') ?>
			</form>
		</div>
		<?php do_action( 'bp_maps_admin_div' );?>
		<div id="donations">
			<h2><?php _e('Support & Donations', 'maps') ;?></h2>
			<h3><?php _e('Donations', 'maps') ;?></h3>
			<p><?php printf(__('Coding this plugin was an long, long way.  If you like it, if you use it, please %s !','maps'),'<a href="http://dev.benoitgreant.be/2010/02/01/buddypress-maps#donate">'.__('Make a donation','maps').'</a>');?>
			<h3><?php _e('Support', 'maps') ;?></h3>
			<p><?php printf(__('You can find installation instructions %s','maps'),'<a href="http://dev.benoitgreant.be/2010/02/01/buddypress-maps">'.__('here','maps').'</a>');?>.</p>
			<p><?php printf(__('Bugs, ideas, ... can be reported into the %s','maps'),'<a href="http://dev.benoitgreant.be/bbpress/forum/buddypress-maps">'.__('support forum','maps').'</a>');?>.</p>
		</div>
	</div>
<?php 
}

function bp_maps_plugin_is_active($file,$sitewide=true) {
	if ($sitewide){
		$plugins = get_site_option( 'active_sitewide_plugins' );
		if ( array_key_exists( $file , $plugins ) ) return true;
	}else{
		$plugins = get_option('active_plugins');
		if ( in_array( $file , $plugins ) ) return true;
	}
}




?>