<?php

///GENERATES JAVASCRIPT IN HEAD
function bp_maps_get_map_js($map) {

	if (!$map) return false;

	$js[]="\n<script type='text/javascript'>";
	$js[]="<!--BP-MAPS #".$map->ID." INIT|START-->";
	
	$js[]="var ".$map->ID."_map;";	
	$js[]="var ".$map->ID."_Options;";
	$js[]="var ".$map->ID."_is_init;";
	
	if ($map->markers_max)
		$js[]="var ".$map->ID."_markers_max=".$map->markers_max.";";

	if ($map->type)
		$js[]="var ".$map->ID."_type='".$map->type."';";
	
	$js[]="var ".$map->ID."_markers=new Array();";
	$js[]="\n\nfunction bp_maps_".$map->ID."_init(){";
	$js[]="\n\n".$map->ID."_is_init=true";
	$js[]="\t".$map->ID."_Options = {";
	
	$point = array($map->Lat,$map->Lng);

	$option_arr[]="\t\tcenter : new google.maps.LatLng(".implode(",",$point).")";
	
	$option_arr[]="\t\tzoom :".$map->zoom;
	$option_arr[]="\t\tmapTypeControlOptions : {style: google.maps.MapTypeControlStyle.".$map->mapTypeControlOptions."}";
	$option_arr[]="\t\tnavigationControlOptions : {style: google.maps.NavigationControlStyle.".$map->navigationControlOptions."}";
	
	$option_arr[]="\t\tmapTypeId : google.maps.MapTypeId.".$map->mapTypeId;
	
	$js[]=implode(",\n",$option_arr);
	
	$js[]="\t};\n";
	

	//MAP INIT
	$js[]="\t".$map->ID."_map = new google.maps.Map(document.getElementById('".$map->ID."_content'), ".$map->ID."_Options);\n";

	//MARKERS INIT
	if ($map->markers) {
		
		foreach ($map->markers as $key=>$marker) {

			//PRIVACY | HIDE
			if (!bp_maps_marker_user_can_view($marker)) {
				$js[]="\t/*[PRIVACY] marker #".$marker->ID." hidden*/";
				continue;
			}

			$marker_var_name = $map->ID.'_marker'.$marker->ID.'_js';
			
			if ((!$marker->Lat) || (!$marker->Lng)) continue;
			
			//PRIVACY | APPROX POINT
			$js[]="\t<!--marker #".$marker->ID."|START-->";
			if (!bp_maps_marker_user_can_view_exact($marker)) {
				$js[]="\t/*[PRIVACY] marker #".$marker->ID." position is not accurate*/";
				$point=BP_Maps_Map_Marker::randomize_location($marker->Lat,$marker->Lng);
			}else {
				$point=array($marker->Lat,$marker->Lng);
			}

			$marker_position = "new google.maps.LatLng(".implode(",",$point).")";
			
			unset($marker_args_str);
			unset($marker_args_arr);
			unset($marker_args);

			$marker_args=array(
				'position'=>$marker_position,
				'map'=>$map->ID.'_map'
			);
			
			if ($map->editable) {
				$marker_args['draggable']='true';
			}

			if ($marker->title)
				$marker_args['title']="'".addslashes($marker->title)."'";


			
			$marker_args=apply_filters('bp_maps_single_marker_js_attr',$marker_args,$marker->ID,$map);


			
			foreach ($marker_args as $name=>$value) {
				$marker_args_arr[]=$name." : ".$value;
			}
			
			unset($marker_args_str);
			
			$marker_args_str=implode(",",$marker_args_arr);
			
			$js[]="\t".$map->ID."_marker_".$marker->ID."= new Object();";
			$js[]="\t".$map->ID."_marker_".$marker->ID."['ID']='".$marker->ID."';";

			
			
			
			$js[]="\t".$map->ID."_marker_".$marker->ID."['marker']=new google.maps.Marker({".$marker_args_str."});";
			
			if (($marker->address) && (bp_maps_marker_user_can_view_exact($marker)))
			$js[]="\t".$map->ID."_marker_".$marker->ID."['address']='".addslashes($marker->address)."';";
			
			$js[]="\t".$map->ID."_markers.push(".$map->ID."_marker_".$marker->ID.");";
			
			if ($marker->content) {
				$js[]="\t".$map->ID."_marker_".$marker->ID."['infoWindow']=new google.maps.InfoWindow({content: '".addslashes($marker->content)."'});";
				$js[]="\t".$map->ID."_marker_".$marker->ID."['listener']=google.maps.event.addListener(".$map->ID."_markers[".$key."]['marker'], 'click', function() {(".$map->ID."_markers[".$key."]['infoWindow'].open(".$map->ID."_map,".$map->ID."_markers[".$key."]['marker']))});";
			}
			$js[]="\t<!--marker #".$marker->ID."|END-->\n";
		}
	}
	
	$js[]="};";
	
	$js = apply_filters('bp_maps_get_map_js',$js,$map);

	
	$js[]="<!--BP-MAPS #".$map->ID." INIT|END-->\n\n";
	$js[]="</script>\n";
	return implode("\n",$js);
}


//returns a random point ~$km from the original point (for privacy)

function bp_maps_map_html($map) {
	echo bp_maps_get_map_html($map);
}

function bp_maps_get_map_html($map) {
	if ((!$map->editable) && (!$map->markers)) return false;

	global $bp;

	$html.=bp_maps_get_map_js($map);
		
	$classes[]='bp_maps_map';	
	if ($map->editable) {
		$classes[]='editable';	
	}
	if ($classes) $classes_str=' class="'.implode(' ',$classes).'"';
	
	$html.='<div rel="'.$map->ID.'" id="'.$map->ID.'"'.$classes_str.'>';

		
		if ($map->editable) {
			$html.=wp_nonce_field($map->ID."_save",$map->ID."_nonce",true,false);
		}


		if (($map->showmarkers) || ($map->editable)) {

			$height = $map->height-25;//css
			$html.='<ul id="'.$map->ID.'_markers" style="padding-top:25px;height:'.$height.'" class="bp_maps_map_markers item-list">';
				if ($map->editable) {
					$html.='<div style="height:25px;margin-top:-25px;" class="bp_maps_map_add_marker"><a href="#">'.__('Add Marker','bp_maps').'</a>';

					if ($map->markers_max)
					$html.=' ('.__('max','bp-maps').': '.$map->markers_max.')';
					
					$html.='</div>';
				}

			//create a fake marker so we still can duplicate html
			if (($map->editable) && (!$map->markers)) {
				$map->markers[] = new BP_Maps_Map_Marker();
				$open_first_marker=true;

			}

			if ($map->markers) {

				foreach ($map->markers as $key=>$marker) {
				
					//PRIVACY | HIDE
					if (!bp_maps_marker_user_can_view($marker))	continue;
				
	
					$marker_name= $map->ID.'_marker'.$marker->ID;


					if ($marker->title) {
						$marker_title=$marker->title;
					}elseif($map->enable_desc) {
						$marker_title=$marker->address;
					}
					
					$marker_id=$key+1;

					$marker_classes=array();
					$marker_classes[]='bp_maps_marker';
					$marker_classes[]='item';
					
					if ($open_first_marker)
						$marker_classes[]='edit';
					
					//PRIVACY | APPROX POINT
					if (!bp_maps_marker_user_can_view_exact($marker)) $marker_classes[]='approx';

					
					$marker_html='<li><div id="'.$map->ID.'_marker'.$marker_id.'" rel="'.$marker_id.'" class="'.implode(" ",$marker_classes).'">';
					$marker_html.='<div class="message"></div>';
					
					
					
					$marker_html.=	'<div class="item-title">';
					$marker_html.=	'<span>'.$marker_title.'</span>';
					
						
					if (($map->enable_desc) && ($map->editable)) {
						$marker_html.=	'<label for "'.$map->ID.'_marker'.$marker_id.'_title"/>'.__('Title','bp-maps').'</label>';
						$marker_html.=	'<input class="input" type="text" name="'.$map->ID.'_marker'.$marker_id.'_title" id="'.$map->ID.'_marker'.$marker_id.'_title" value="'.$marker_title='">';
					}
					
					$marker_html.=	'</div>';
					
					if ($map->editable) {
						$marker_html.=	'<div class="address">';
						$marker_html.=	'<span>'.$marker->address.'</span>';
						$marker_html.=	'<label for "'.$map->ID.'_marker'.$marker_id.'_address"/>'.__('Address','bp-maps').'</label>';
						$marker_html.=	'<input class="input" type="text" name="'.$map->ID.'_marker'.$marker_id.'_address" id="'.$map->ID.'_marker'.$marker_id.'_address" value="'.$marker->address.'">';
						$marker_html.=	'<a class="button search" href="#">'.$texts.search.'</a>';
						$marker_html.=	'</div>';
					
						//PRIVACY
						
						$marker_html.=	'<div class="privacy">';
						$marker_html.=	'<label for "'.$map->ID.'_marker'.$marker_id.'_address"/>'.__('Privacy','bp-maps').'</label>';
						$marker_html.=	'<small>'.__('if you are concerned about privacy, check here which users will see an approximate location and which ones will not be able to see your marker','bp-maps').'</small>';
						
						
						//TABLE
						
						if ($bp->maps->options['marker']['privacy']) {
						
							$privacy_actions = array_reverse($bp->maps->options['marker']['privacy']);
							
							
							$marker_html.=	'<table><tr>';
							foreach ($bp->maps->privacy['levels'] as $name=>$fn) {
								$marker_html.='<th>'.$name.'</th>';
							}
							$marker_html.='<th></th>';
							
							$marker_html.=	'</tr>';
							foreach ($privacy_actions as $mname=>$level) {
								$marker_html.=	'<tr class="bp_maps_privacy_action">';
								
									$key=0;
									foreach ($bp->maps->privacy['levels'] as $lname=>$fn) {
										if ($level==$key) $checked=" CHECKED";
										$marker_html.='<td><input name="'.$mname.'" type="radio" value="'.$key.'"'.$checked.'></td>';
										unset($checked);
										$key++;
									}
								$marker_html.='<td><input name="'.$mname.'" type="checkbox" value="1">'.$mname.'</td>';
								$marker_html.=	'</tr>';
							}
							$marker_html.=	'</table>';
							
						}

						$marker_html.=	'</div>';
					}
					
					if ($map->enable_desc) {

						$marker_html.=	'<div class="content">';
						$marker_html.=	'<span>'.$newmarker_content.'</span>';
						$marker_html.=	'<label for "'.$map->ID.'_marker'.$marker_id.'_content"/>'.__('Description','bp-maps').'</label>';
						$marker_html.=	'<input type="text" name="'.$map->ID.'_marker'.$marker_id.'_content" id="'.$map->ID.'_marker'.$marker_id.'_content" value="'.$newmarker_content.'">';
						$marker_html.=	'</div>';
					
					}

					$marker_html.=	'<div class="action">';
					$marker_html.=	'<a class="button edit" href="#">'.__('Open','bp-maps').'</a>';
					
					if ($map->editable) {
						$marker_html.=	'<a class="button save" href="#">'.__('Save','bp-maps').'</a>';
						$marker_html.=	'<a class="button delete" href="#">'.__('Delete','bp-maps').'</a>';
					}
					
					$marker_html.=	'<a class="button close" href="#">'.__('Close','bp-maps').'</a>';
					$marker_html.=	'</div>';

					$marker_html.=	'</div></li>';
					
					$markers_html[]=$marker_html;
				}
				
				rsort($markers_html);
				$html.=implode("\n",$markers_html); //good order for jquery
				
			}
			
			$html.='</ul>';
		}

		$map_classes[]='bp_maps_map_container';

		$map_classes[]=$map->display;
			
		if ($map_classes)
			$map_classes_str=' class="'.implode(' ',$map_classes).'"';

		$html.='<div id="'.$map->ID.'_content" style="width:'.$map->width.'px;height:'.$map->height.'px"'.$map_classes_str.'>';

		if ($map->display!='dynamic') //STATIC IMAGE
			$html.='<img src="'.$map->image.'">';
			
		$html.='</div>';
		
		//PRIVACY | APPROX POINT
		if ($map->markers) {
			foreach ($map->markers as $key=>$marker) {
				if (!bp_maps_marker_user_can_view_exact($marker)) {
					$privacy_alert++;
				}
			}
		}
		if ($privacy_alert)
			$html.=__('Some markers on this map may not be accurate (privacy settings)');
	$html.='</div>';
  

	return apply_filters('bp_maps_get_map_html',$html);
}

//////////////TEMPLATES////////////////////


function bp_maps_enqueue_url($file){
	// split template name at the slashes
	
	$stylesheet_path = get_stylesheet_directory_uri();
	$suffix = explode($stylesheet_path,$file);	
	
	$suffix_str=$suffix[1];
	
	$file_path_to_check = BP_MAPS_PLUGIN_DIR . '/theme'.$suffix_str;
	$file_url_to_return = BP_MAPS_PLUGIN_URL . '/theme'.$suffix_str;

	if ( file_exists($file)) {
		return $file;
	}elseif ( file_exists($file_path_to_check)) {
		return $file_url_to_return;
	}
}
add_filter( 'bp_maps_enqueue_url', 'bp_maps_enqueue_url' );

/**
 * Check if template exists in style path, then check custom plugin location (code snippet from MrMaz)
 *
 * @param array $template_names
 * @param boolean $load Auto load template if set to true
 * @return string
 */
function bp_maps_locate_template( $template_names, $load = false ) {

	if ( !is_array( $template_names ) )
		return '';

	$located = '';
	foreach($template_names as $template_name) {

		// split template name at the slashes
		$paths = explode( '/', $template_name );
		
		// only filter templates names that match our unique starting path
		if ( !empty( $paths[0] ) && 'maps' == $paths[0] ) {


			$style_path = STYLESHEETPATH . '/' . $template_name;
			$plugin_path = BP_MAPS_PLUGIN_DIR . "/theme/{$template_name}";

			if ( file_exists( $style_path )) {
				$located = $style_path;
				break;
			} else if ( file_exists( $plugin_path ) ) {
				$located = $plugin_path;
				break;
			}
		}
	}

	if ($load && '' != $located)
		load_template($located);

	return $located;
}

/**
 * Filter located BP template (code snippet from MrMaz)
 *
 * @see bp_core_load_template()
 * @param string $located_template
 * @param array $template_names
 * @return string
 */
function bp_maps_filter_template( $located_template, $template_names ) {

	// template already located, skip
	if ( !empty( $located_template ) )
		return $located_template;

	// only filter for our component
	if ( $bp->current_component == $bp->maps->slug ) {
		return bp_maps_locate_template( $template_names );
	}

	return '';
}
add_filter( 'bp_located_template', 'bp_maps_filter_template', 10, 2 );

/**
 * Use this only inside of screen functions, etc (code snippet from MrMaz)
 *
 * @param string $template
 */
function bp_maps_load_template( $template ) {
	bp_core_load_template( $template );
}


?>